// CoNLL-U SVG Editor & Viewer (L-to-R) by Koichi Yasuoka, November 16, 2017.
// Nos. 1, 2, 4, 5, 7, and 8 columns are used.
var conllusvg;
{ var x=function(){
    this.main=new Array();
  }
  conllusvg=new x();
}
conllusvg.init=function(svg,id,lowid,ftid){
  var c=conllusvg.main;
  if(c[id]==null){
    var x=function(svg){
      this.svg=svg;
    }
    c[id]=new x(svg);
  }
  c[id].svg=svg;
  c[id].height=0;
  if(lowid==null)
    c[id].lowerlink=false;
  else if(lowid==true)
    c[id].lowerlink=true;
  else if(lowid==false)
    c[id].lowerlink=false;
  else
    c[id].lowerlink=document.getElementById(lowid).checked;
  if(ftid==null)
    c[id].editable=false;
  else{
    c[id].feature=document.getElementById(ftid);
    c[id].editable=true;
    if(conllusvg.jsreq==null){
      conllusvg.jsreq=new XMLHttpRequest();
      conllusvg.jsreq.open("GET","conllusvg.js",true);
      conllusvg.jsreq.send();
    }
  }
  conllusvg.parse(id);
}
conllusvg.invert=function(id,input){
  var c=conllusvg.main[id];
  c.lowerlink=input.checked;
  if(c.lowerlink)
    c.nodesvg.setAttribute("y",25);
  else
    c.nodesvg.setAttribute("y",c.height*25+25);
  conllusvg.writelinks(id);
}
conllusvg.parse=function(id){
  var c=conllusvg.main[id];
  c.selectedPath=0;
  c.selectedNode=0;
  c.lastX=0;
  c.lastY=0;
  conllusvg.parseinternal(id);
}
conllusvg.parseinternal=function(id){
  var c,s,state,i,j,k,p;
  c=conllusvg.main[id];
  p=document.getElementById(id);
  if(p.value!=null)
    s=p.value;
  else
    s=p.textContent;
  c.texts=new Array();
  c.nodes=new Array();
  c.links=new Array();
  c.height=0;
  state="sep";
  i=j=0;
  for(k=0;k<s.length;k++){
    var t=s.substring(k,k+1);
    if(state=="sep"){
      if(t==" "||t=="\t")
	;
      else if(t=="\n"||t=="\r"){
	j=0;
	i++;
      }
      else if(t=="#")
	state="com";
      else{
	state="char";
	p="X"+t;
	j++;
      }
    }
    else if(state=="com"){
      if(t=="\n"||t=="\r"){
	state="sep";
	j=0;
	i++;
      }
    }
    else if(state=="char"){
      if(t==" "||t=="\t"||t=="\n"||t=="\r"){
	if(c.texts[i]==null)
	  c.texts[i]=new Array();
	if(c.texts[i][j]==null){
	  var x=function(anchor){
	    this.anchor=anchor;
	  }
	  c.texts[i][j]=new x(k);
	}
	c.texts[i][j].value=p.substring(1,p.length);
	c.texts[i][j].anchor=k;
	if(j==1){
	  var x=function(texts){
	    this.texts=texts;
	  }
	  c.nodes[c.texts[i][1].value]=new x(c.texts[i]);
	}
	else if(j==7){
	  var from,to;
	  to=c.texts[i][1].value;
	  from=c.texts[i][7].value;
	  if(parseInt(from)==from&&parseInt(to)==to){
	    var x=function(linkfrom){
	      this.linkfrom=linkfrom;
	    }
	    c.links[to]=new x(from);
	  }
	}
	state="sep";
	if(t=="\n"||t=="\r"){
	  j=0;
	  i++
	}
      }
      else
	p=p+t;
    }
  }
  conllusvg.checklinkheight(id);
  conllusvg.writenodes(id);
  conllusvg.writelinks(id);
}
conllusvg.feature=function(id,ftid){
  var c,p,f;
  c=conllusvg.main[id];
  if(c.selectedPath==0)
    return;
  f=document.getElementById(ftid);
  i=f.selectedIndex;
  if(i<0)
    return;
  p=c.links[c.selectedPath];
  if(p.tbox.textContent==f.options[i].textContent)
    return;
  conllusvg.change(id,c.selectedPath,8,f.options[i].textContent);
  conllusvg.writelinks(id);
}
conllusvg.change=function(id,n,col,newvalue){
  var c=conllusvg.main[id];
  if(c.editable){
    var p,s,t,old,anc;
    p=document.getElementById(id);
    if(p.value==null)
      return;
    s=newvalue;
    t=p.value;
    if(c.nodes[n].texts[col]!=null){
      anc=c.nodes[n].texts[col].anchor;
      old=""+c.nodes[n].texts[col].value;
    }
    else{
      var i=col-1;
      s=" "+s;
      while(c.nodes[n].texts[i]==null&&i>1){
	s=" _"+s;
	i--;
      }
      anc=c.nodes[n].texts[i].anchor;
      old="";
    }
    p.value=t.substring(0,anc-old.length)+s+t.substring(anc,t.length);
    conllusvg.parseinternal(id);
  }
}
conllusvg.create=function(type){
  return(document.createElementNS("http://www.w3.org/2000/svg",type));
}
conllusvg.createtext=function(x,y,fontsize){
  var t=conllusvg.create("text");
  t.setAttribute("x",x);
  t.setAttribute("y",y);
  t.setAttribute("text-anchor","middle");
  t.setAttribute("font-family","sans-serif");
  t.setAttribute("font-size",fontsize);
  return(t);
}
conllusvg.writenodes=function(id){
  var c,x,w;
  c=conllusvg.main[id];
  if(c.nodesvg!=null)
    c.svg.removeChild(c.nodesvg);
  c.nodesvg=conllusvg.create("svg");
  c.nodesvg.setAttribute("x",0);
  if(c.lowerlink)
    c.nodesvg.setAttribute("y",25);
  else
    c.nodesvg.setAttribute("y",c.height*25+25);
  if(c.editable){
    c.nodesvg.addEventListener("mousedown",conllusvg.nodemousedown);
    c.nodesvg.addEventListener("touchstart",conllusvg.nodemousedown);
    c.nodesvg.addEventListener("mouseup",conllusvg.nodemouseup);
  }
  c.svg.appendChild(c.nodesvg);
  w=0;
  for(x in c.nodes){
    if(parseInt(x)==x){
      var t,p;
      t=conllusvg.createtext(x*100-50,60,30);
      t.textContent=c.nodes[x].texts[2].value;
      c.nodes[x].wordbox=t;
      c.nodesvg.appendChild(t);
      p=c.nodes[x].texts[4].value;
      if(p!=null&&p!="_"){
	var b;
        t=conllusvg.createtext(x*100-50,17,15);
	t.textContent=p;
	c.nodesvg.appendChild(t);
	b=t.getBBox();
	t=conllusvg.create("rect");
	t.setAttribute("x",x*100-50-b.width/2-5);
	t.setAttribute("y",1);
	t.setAttribute("width",b.width+10);
	t.setAttribute("height",20);
	t.setAttribute("rx",5);
	t.setAttribute("ry",5);
	t.setAttribute("fill","none");
	t.setAttribute("stroke","black");
	t.setAttribute("stroke-width",2);
	c.nodesvg.appendChild(t);
      }
      p=c.nodes[x].texts[5].value;
      if(p!=null&&p!="_"){
	t=conllusvg.createtext(x*100-50,30,8);
	t.textContent=p;
        c.nodesvg.appendChild(t);
      }
      if(w-x<0)
	w=x;
    }
  }
  c.width=w;
  c.svg.setAttribute("width",w*100);
  c.nodesvg.setAttribute("width",w*100);
  c.nodesvg.setAttribute("height",70);
  for(x in c.nodes){
    var i=x.indexOf("-");
    if(i>0){
      var p=c.nodes[x].texts[2].value;
      if(p!=null&&p!="_"){
	var j,k,t;
	j=x.substring(0,i);
	k=x.substring(i+1,x.length);
	for(i=j;i<=k;i++){
	  if(c.nodes[i].wordbox!=null)
	    c.nodesvg.removeChild(c.nodes[i].wordbox);
	}
	t=conllusvg.createtext(j*50+k*50-50,60,30);
	t.textContent=p;
	c.nodesvg.appendChild(t);
      }
    }
  }
}
conllusvg.checklinkheight=function(id){
  var c,x,h;
  c=conllusvg.main[id];
  for(x in c.links){
    c.links[x].myupper=-1;
    c.links[x].height=1;
  }
  for(x in c.links){
    if(c.links[x].linkfrom==0){
      var y;
      for(y in c.links){
	if(x!=y){
	  if(c.links[y].linkfrom==x)
	    c.links[y].myupper=x;
	}
      }
    }
  }
  for(x in c.links){
    if(c.links[x].linkfrom!=0){
      var m,n,y;
      m=Math.min(x,c.links[x].linkfrom);
      n=Math.max(x,c.links[x].linkfrom);
      for(y in c.links){
	if(x!=y&&c.links[y].linkfrom!=0){
	  var z=y,zz=-1;
	  while(true){
	    var mm,nn;
      	    mm=Math.min(z,c.links[z].linkfrom);
            nn=Math.max(z,c.links[z].linkfrom);
	    if(mm==0)
	      break;
	    else if(m<=mm&&nn<=n){
	      zz=z;
	      z=c.links[zz].myupper;
	      if(z==-1||z==x)
		break;
	    }
	    else
	      break;
	  }
	  if(zz!=-1&&z!=x){
	    c.links[x].myupper=c.links[zz].myupper;
	    c.links[zz].myupper=x;
	  }
	}
      }
    }
  }
  for(x in c.links){
    if(c.links[x].linkfrom==0){
      var y;
      for(y in c.links){
	if(x!=y&&c.links[y].linkfrom!=0){
	  var m,n;
      	  m=Math.min(y,c.links[y].linkfrom);
          n=Math.max(y,c.links[y].linkfrom);
	  if(m<=x&&x<=n){
	    if(c.links[y].myupper==-1)
	      c.links[y].myupper=x;
	  }
	}
      }
    }
  }
  h=0;
  for(x in c.links){
    var y=x;
    while(true){
      var z=c.links[y].myupper;
      if(z==-1)
	break;
      c.links[z].height=Math.max(c.links[z].height,c.links[y].height+1);
      y=z;
    }
    if(c.links[y].height>h)
      h=c.links[y].height;
  }
  c.height=h;
}
conllusvg.writelinks=function(id){
  var c,x,ydelta;
  c=conllusvg.main[id];
  if(c.linksvg!=null)
    c.svg.removeChild(c.linksvg);
  c.linksvg=conllusvg.create("svg");
  c.linksvg.setAttribute("x",0);
  if(c.lowerlink){
    c.linksvg.setAttribute("y",90);
    ydelta=5;
  }
  else{
    c.linksvg.setAttribute("y",0);
    ydelta=-5;
  }
  c.linksvg.setAttribute("width",c.width*100);
  c.linksvg.setAttribute("height",c.height*25+25);
  c.svg.setAttribute("height",c.height*25+100)
  if(c.editable){
    c.linksvg.addEventListener("mousedown",conllusvg.linkmousedown);
    c.linksvg.addEventListener("touchstart",conllusvg.linkmousedown);
  }
  c.svg.appendChild(c.linksvg);
  for(x in c.links){
    var f,xfrom,xto,ybottom,ytop,p,b;
    f=c.links[x].linkfrom;
    xto=x*100-50;
    if(f==0)
      xfrom=xto;
    else{
      xfrom=f*100-50;
      if(c.links[f]!=null){
	var j=c.links[f].linkfrom;
	if(f-x>0){
	  xfrom-=10;
	  if(f-j>0&&j-x>0)
	    xfrom+=20;
	}
	else{
	  xfrom+=10;
	  if(x-j>0&&j-f>0)
	    xfrom-=20;
	}
      }
    }
    if(c.lowerlink){
      ybottom=0;
      ytop=c.links[x].height*25;
    }
    else{
      ybottom=c.height*25+25;
      ytop=ybottom-c.links[x].height*25;
    }
    p=conllusvg.createtext((xfrom+xto)/2,ytop+5,15);
    if(c.nodes[x].texts[8]==null)
      b="???";
    else{
      b=c.nodes[x].texts[8].value;
      if(b==null||b=="_")
        b="???";
    }
    p.textContent=b;
    if(c.selectedPath==x){
      p.setAttribute("fill","red");
      if(c.editable){
        var k;
        for(k=c.feature.options.length-1;k>=0;k--){
	  if(b==c.feature.options[k].textContent)
	    break;
        }
        c.feature.selectedIndex=k;
      }
    }
    c.linksvg.appendChild(p);
    c.links[x].tbox=p;
    c.links[x].xmax=Math.max(xfrom,xto);
    c.links[x].xmin=Math.min(xfrom,xto);
    c.links[x].ytop=ytop;
    b=p.getBBox();
    if(b.width>Math.abs(xfrom-xto)-10){
      p.setAttribute("font-size",(Math.abs(xfrom-xto)-10)*15/b.width);
      b=p.getBBox();
    }
    p=conllusvg.create("path");
    p.setAttribute("fill","none");
    if(c.selectedPath==x)
      p.setAttribute("stroke","red");
    else
      p.setAttribute("stroke","black");
    p.setAttribute("stroke-width",1);
    if(f==0)
      p.setAttribute("d","M "+xfrom+" "+ybottom+" v "+(ytop-ybottom-ydelta));
    else{
      var xdelta,bdelta;
      if(xto>xfrom){
	xdelta=-5;
	bdelta=-b.width;
      }
      else{
	xdelta=5;
	bdelta=b.width;
      }
      p.setAttribute("d","M "+xfrom+" "+ybottom+" v "+(ytop-ybottom-ydelta)+" q 0 "+ydelta+" "+(-xdelta)+" "+ydelta+" h "+((xto-xfrom+bdelta)/2+xdelta)+" m "+(-bdelta)+" 0 h "+((xto-xfrom+bdelta)/2+xdelta)+" q "+(-xdelta)+" 0 "+(-xdelta)+" "+(-ydelta)+" v "+(ybottom-ytop+ydelta));
    }
    c.linksvg.appendChild(p);
    c.links[x].path=p;
    p=conllusvg.create("path");
    if(c.selectedPath==x)
      p.setAttribute("fill","red");
    else
      p.setAttribute("fill","black");
    if(c.lowerlink)
      p.setAttribute("d","M "+xto+" "+ybottom+" l -4 10 h 8 Z");
    else
      p.setAttribute("d","M "+xto+" "+ybottom+" l -4 -10 h 8 Z");
    c.linksvg.appendChild(p);
    c.links[x].triangle=p;
  }
}
conllusvg.linkmousedown=function(e){
  var id,c,x,y,i,j,k;
  for(id in conllusvg.main){
    if(conllusvg.main[id].linksvg==e.currentTarget)
      break;
  }
  c=conllusvg.main[id];
  k=c.svg.getBoundingClientRect();
  x=e.clientX-k.left;
  y=e.clientY-k.top;
  if(c.lowerlink)
    y-=90;
  i=0;
  j=c.height*25+25;
  for(k in c.links){
    if(c.links[k].xmin-x<20&&x-c.links[k].xmax<20){
      var l=Math.abs(y-c.links[k].ytop);
      if(j>l){
	j=l;
	i=k;
      }
    }
  }
  if(i>0){
    j=c.selectedPath;
    if(j>0){
      c.links[j].tbox.setAttribute("fill","black");
      c.links[j].path.setAttribute("stroke","black");
      c.links[j].triangle.setAttribute("fill","black");
    }
    if(i==j)
      c.selectedPath=0;
    else{
      c.links[i].tbox.setAttribute("fill","red");
      c.links[i].path.setAttribute("stroke","red");
      c.links[i].triangle.setAttribute("fill","red");
      j=c.links[i].tbox.textContent;
      c.selectedPath=i;
      for(k=c.feature.options.length-1;k>=0;k--){
	if(j==c.feature.options[k].textContent)
	  break;
      }
      c.feature.selectedIndex=k;
    }
  }
}
conllusvg.nodemousedown=function(e){
  var id,c,x,y,k;
  for(id in conllusvg.main){
    if(conllusvg.main[id].nodesvg==e.currentTarget)
      break;
  }
  c=conllusvg.main[id];
  k=c.svg.getBoundingClientRect();
  x=e.clientX-k.left;
  y=e.clientY-k.top;
  if(c.lowerlink)
    y-=25;
  else
    y-=c.height*25+25;
  if(x%100<25&&x%100>75)
    return;
  k=Math.ceil(x/100);
  if(c.nodes[k]==null)
    return;
  if(c.selectedNode==0){
    c.selectedNode=k;
    c.lastX=x;
    c.lastY=y;
    c.nodesvg.addEventListener("mousemove",conllusvg.nodemousemove);
  }
  else{
    c.lastX=0;
    c.lastY=0;
    if(c.path!=null){
      c.nodesvg.removeChild(c.path);
      c.nodesvg.removeChild(c.triangle);
      c.path=null;
    }
    c.nodesvg.removeEventListener("mousemove",conllusvg.nodemousemove);
    if(c.selectedNode!=k){
      var i=c.selectedNode;
      c.selectedNode=0;
      c.selectedPath=k;
      conllusvg.change(id,k,7,i);
      if(c.nodes[k].texts[8]!=null){
        if(c.nodes[k].texts[8].value=="root")
          conllusvg.change(id,k,8,"_");
      }
    }
    else{
      c.selectedNode=0;
      c.selectedPath=k;
      conllusvg.change(id,k,7,0);
      conllusvg.change(id,k,8,"root");
    }
  }
}
conllusvg.nodemouseup=function(e){
  var id,c,x,y,k,p;
  for(id in conllusvg.main){
    if(conllusvg.main[id].nodesvg==e.currentTarget)
      break;
  }
  c=conllusvg.main[id];
  if(c.selectedNode==0)
    return;
  k=c.svg.getBoundingClientRect();
  x=e.clientX-k.left;
  y=e.clientY-k.top;
  if(c.lowerlink)
    y-=25;
  else
    y-=c.height*25+25;
  k=Math.ceil(x/100);
  if(c.nodes[k]==null)
    return;
  if(c.selectedNode==k)
    return;
  c.lastX=0;
  c.lastY=0;
  if(c.path!=null){
    c.nodesvg.removeChild(c.path);
    c.nodesvg.removeChild(c.triangle);
    c.path=null;
    c.triangle=null;
  }
  c.nodesvg.removeEventListener("mousemove",conllusvg.nodemousemove);
  x=c.selectedNode;
  c.selectedNode=0;
  c.selectedPath=k;
  conllusvg.change(id,k,7,x);
  if(c.nodes[k].texts[8]!=null){
    if(c.nodes[k].texts[8].value=="root")
      conllusvg.change(id,k,8,"_");
  }
}
conllusvg.nodemousemove=function(e){
  var id,c,x,y,i,j,k;
  for(id in conllusvg.main){
    if(conllusvg.main[id].nodesvg==e.currentTarget)
      break;
  }
  c=conllusvg.main[id];
  if(c.selectedNode==0)
    return;
  k=c.svg.getBoundingClientRect();
  x=e.clientX-k.left;
  y=e.clientY-k.top;
  if(c.lowerlink)
    y-=25;
  else
    y-=c.height*25+25;
  if(c.path==null){
    p=conllusvg.create("path")
    p.setAttribute("stroke","red");
    p.setAttribute("fill","none");
    p.setAttribute("stroke-width",1);
  }
  else
    p=c.path;
  p.setAttribute("d","M "+c.lastX+" "+c.lastY+" L "+x+" "+y);
  c.path=p;
  c.nodesvg.appendChild(p);
  if(c.triangle==null){
    p=conllusvg.create("path");
    p.setAttribute("fill","red");
    p.setAttribute("d","M 0 0 l -4 -10 h 8 Z");
  }
  else
    p=c.triangle;
  i=x-c.lastX;
  j=y-c.lastY;
  k=Math.sqrt(i*i+j*j);
  p.setAttribute("transform","matrix("+(j/k)+" "+(-i/k)+" "+(i/k)+" "+(j/k)+" "+x+" "+y+")");
  c.triangle=p;
  c.nodesvg.appendChild(p);
}
conllusvg.loadtxt=function(id){
  var c=conllusvg.main[id];
  if(c.editable){
    var i=document.createElement("input");
    i.setAttribute("style","opacity:0; position:absolute; right:0; top:0");
    i.setAttribute("type","file");
    i.setAttribute("onchange","conllusvg.loadtxtinternal('"+id+"',this)");
    document.body.appendChild(i);
    c.inputload=i;
    c.reader=null;
    i.click();
    if(c.reader==null){
      document.body.removeChild(i);
      c.inputload=null;
    }
  } 
}
conllusvg.loadtxtinternal=function(id,input){
  var c=conllusvg.main[id];
  if(c.editable){
    c.reader=new FileReader();
    c.reader.addEventListener("load",conllusvg.loadtxtend);
    c.reader.readAsText(input.files[0]);
    c.filename=input.files[0].name;
  }
}
conllusvg.loadtxtend=function(e){
  var id,c,p;
  for(id in conllusvg.main){
    if(conllusvg.main[id].reader==e.currentTarget)
      break;
  }
  c=conllusvg.main[id];
  c.reader.removeEventListener("load",conllusvg.loadtxtend);
  if(c.inputload!=null){
    document.body.removeChild(c.inputload);
    c.inputload=null;
  }
  p=document.getElementById(id);
  if(p.value!=null){
    p.value=c.reader.result;
    conllusvg.parse(id);
  }
  c.reader=null;
}
conllusvg.savetxt=function(id){
  var c=conllusvg.main[id];
  if(c.editable){
    var s,b,f;
    s=document.getElementById(id).value;
    if(s.substring(s.length-1,s.length)!="\n")
      s=s+"\n";
    b=new Blob([s],{"type":"text/plain"});
    f=c.filename;
    if(f==null)
      f="conllu.txt";
    if(window.navigator.msSaveBlob)
      window.navigator.msSaveBlob(b,f);
    else{
      var a=document.createElement("a");
      a.href=window.URL.createObjectURL(b);
      a.target="_blank";
      a.download=f;
      document.body.appendChild(a);
      a.click();
      document.body.removeChild(a);
    }
  }
}
conllusvg.savesvg=function(id){
  var c=conllusvg.main[id];
  if(c.editable){
    var s,b,f;
    s=new Array();
    s[0]='<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="'+(c.width*100)+'" height="'+(c.height*25+100)+'" onload="conllusvg.init(this,'+"'conllu'"+','+c.lowerlink+')">\n';
    s[1]='<text id="conllu" fill="none" visibility="hidden">\n'
    s[2]=document.getElementById(id).value;
    s[3]='</text>\n'
    s[4]='<script type="text/javascript" xlink:href="conllusvg.js" />\n';
    s[5]='</svg>\n';
    if(conllusvg.jsreq!=null){
      if(conllusvg.jsreq.readyState==4){
	var m="]";
	s[3]='</text><script type="text/javascript"><![CDATA[\n';
	s[4]=conllusvg.jsreq.responseText;
	s[5]=m+m+"></script></svg>\n";
      }
    }
    b=new Blob(s,{"type":"text/plain"});
    f=c.filename;
    if(f==null)
      f="conllu.svg";
    else if(f.lastIndexOf(".")>0)
      f=f.substring(0,f.lastIndexOf("."))+".svg";
    if(window.navigator.msSaveBlob)
      window.navigator.msSaveBlob(b,f);
    else{
      var a=document.createElement("a");
      a.href=window.URL.createObjectURL(b);
      a.target="_blank";
      a.download=f;
      document.body.appendChild(a);
      a.click();
      document.body.removeChild(a);
    }
  }
}
